#include "JVizObjectObj.h"
#include "JInteger.h"
#include "JIntegerData.h"
#include "JStringData.h"
#include "JIntegerProperty.h"
#include "JIntegerListProperty.h"
#include "JStringProperty.h"
#include "JLinkObj.h"
#include "JBytesData.h"


char* theJVizObjectObj = JVizObjectObj().Register();


void JVizObjectObj::writeContent(JOutputStream& os) {
  JAddObj::writeContent(os);
  putObject(os, "viz_name", viz_name);
  putObject(os, "ext_1p", ext_1p);
  putObject(os, "ext_2p", ext_2p);
  putObject(os, "ext_3p", ext_3p);
  putObject(os, "ext_4p", ext_4p);
  putObject(os, "ext_5p", ext_5p);
}

void JVizObjectObj::readContent(JDictionary& dict) {
  JAddObj::readContent(dict);
  JObject* obj_viz_name = getObject( dict, "viz_name");
  if ( obj_viz_name ) viz_name = *(JString*)obj_viz_name;
  JObject* obj_ext_1p = getObject( dict, "ext_1p");
  if ( obj_ext_1p ) ext_1p = *(JString*)obj_ext_1p;
  JObject* obj_ext_2p = getObject( dict, "ext_2p");
  if ( obj_ext_2p ) ext_2p = *(JString*)obj_ext_2p;
  JObject* obj_ext_3p = getObject( dict, "ext_3p");
  if ( obj_ext_3p ) ext_3p = *(JString*)obj_ext_3p;
  JObject* obj_ext_4p = getObject( dict, "ext_4p");
  if ( obj_ext_4p ) ext_4p = *(JString*)obj_ext_4p;
  JObject* obj_ext_5p = getObject( dict, "ext_5p");
  if ( obj_ext_5p ) ext_5p = *(JString*)obj_ext_5p;
}

const char* JVizObjectObj::className() const { return "JVizObjectObj";}


JObject* JVizObjectObj::clone() const { return new JVizObjectObj(*this);}


// class constructor
JVizObjectObj::JVizObjectObj() {
  igm = 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1;
  ogm = 1;
  transparency = 0;
  x = 0;
  y = 0;
  z = 0;
  red = 0;
  green = 0;
  blue = 0;
  xscale = 0;
  yscale = 0;
  zscale = 0;
  scale = 0;
  rotation = 0;
  ext_1 = 0;
  ext_2 = 0;
  ext_3 = 0;
  ext_4 = 0;
  ext_5 = 0;
}


void JVizObjectObj::draw(JGraphics g, int x, int y, int w, int h) {
  JRect rect(x, y, w, h);
  if (viz_name.length() == 0) {
	drawText(g, JString("VizO"), rect);
  } else {
	drawText(g, viz_name, rect);
  }
}


boolean JVizObjectObj::inputAllowed(int n)
{ return !inputSet(n).last();}
JString JVizObjectObj::inputTag(int n) {
  char* tag[] = {
    "transparency",
    "x",
    "y",
    "z",
    "red",
    "green",
    "blue",
    "xscale",
    "yscale",
    "zscale",
    "scale",
    "rotation",
    "ext_1",
    "ext_2",
    "ext_3",
    "ext_4",
    "ext_5" };
  return( tag[n] );
}


int JVizObjectObj::outputType( int n ) {
  if ( n == 0 ) return JStringData::id;
  return JIntegerData::id;
}
JString JVizObjectObj::outputTag(int n) {
  char* tag[] = {
    "result" };
  return( tag[n] );
}


JFRect JVizObjectObj::inputArea(int n) {
  //if ( n < ( 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 )) {
    return leftArea( n, 0, 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1, 0.1, 0.8 );
  //}
}


JFRect JVizObjectObj::outputArea(int n) {
  return rightArea(n, 0, 1);
}


int JVizObjectObj::inputFace(int n) {
  if ( n < 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 ) {
    return LEFT;
  } else {
    return TOP;
  }
}


int JVizObjectObj::outputFace(int n) {
  return RIGHT;
}


JFPoint JVizObjectObj::inputPoint(int n, JLinkObj& link) {
  return leftPoint( n, link, 0, 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1 + 1, 0.1, 0.8);
}


JFPoint JVizObjectObj::outputPoint(int n, JLinkObj& link) {
  return rightPoint(n, link, 0, 1);
}


void JVizObjectObj::access(int n, JLinkObj& link, const JDataType& data) {
  if ( n == 0 ) {
    JSTRING(data) = result;
  }
}

#include <stdio.h>
void JVizObjectObj::engine(int n, JLinkObj& link) {
	char buf[100];
  switch (n) {
  case TRANSPARENCY:
    link.access(JIntegerData(transparency));
	sprintf( buf, "%d", transparency );
	result = JString( viz_name ) + JString( ",transparency," ) + JString( buf );
	broadcast( 0 );
    break;
  case X:
    link.access(JIntegerData(x));
	sprintf( buf, "%d", x );
	result = JString( viz_name ) + JString( ",x," ) + JString( buf );
	broadcast( 0 );
    break;
  case Y:
    link.access(JIntegerData(y));
	sprintf( buf, "%d", y );
	result = JString( viz_name ) + JString( ",y," ) + JString( buf );
	broadcast( 0 );
    break;
  case Z:
    link.access(JIntegerData(z));
	sprintf( buf, "%d", z );
	result = JString( viz_name ) + JString( ",z," ) + JString( buf );
	broadcast( 0 );
    break;
  case RED:
    link.access(JIntegerData(red));
	sprintf( buf, "%d", red );
	result = JString( viz_name ) + JString( ",red," ) + JString( buf );
	broadcast( 0 );
    break;
  case GREEN:
    link.access(JIntegerData(green));
	sprintf( buf, "%d", green );
	result = JString( viz_name ) + JString( ",green," ) + JString( buf );
	broadcast( 0 );
    break;
  case BLUE:
    link.access(JIntegerData(blue));
	sprintf( buf, "%d", blue );
	result = JString( viz_name ) + JString( ",blue," ) + JString( buf );
	broadcast( 0 );
    break;
  case XSCALE:
    link.access(JIntegerData(xscale));
	sprintf( buf, "%d", xscale );
	result = JString( viz_name ) + JString( ",xscale," ) + JString( buf );
	broadcast( 0 );
    break;
  case YSCALE:
    link.access(JIntegerData(yscale));
	sprintf( buf, "%d", yscale );
	result = JString( viz_name ) + JString( ",yscale," ) + JString( buf );
	broadcast( 0 );
    break;
  case ZSCALE:
    link.access(JIntegerData(zscale));
	sprintf( buf, "%d", zscale );
	result = JString( viz_name ) + JString( ",zscale," ) + JString( buf );
	broadcast( 0 );
    break;
  case SCALE:
    link.access(JIntegerData(scale));
	sprintf( buf, "%d", scale );
	result = JString( viz_name ) + JString( ",scale," ) + JString( buf );
	broadcast( 0 );
    break;
  case ROTATION:
    link.access(JIntegerData(rotation));
	sprintf( buf, "%d", rotation );
	result = JString( viz_name ) + JString( ",rotation," ) + JString( buf );
	broadcast( 0 );
    break;
  case EXT_1:
    link.access(JIntegerData(ext_1));
	sprintf( buf, "%d", ext_1 );
	result = JString( viz_name ) + JString( "," ) + ext_1p + JString( "," ) + JString( buf );
	broadcast( 0 );
    break;
  case EXT_2:
    link.access(JIntegerData(ext_2));
	sprintf( buf, "%d", ext_2 );
	result = JString( viz_name ) + JString( "," ) + ext_2p + JString( "," ) + JString( buf );
	broadcast( 0 );
    break;
  case EXT_3:
    link.access(JIntegerData(ext_3));
	sprintf( buf, "%d", ext_3 );
	result = JString( viz_name ) + JString( "," ) + ext_3p + JString( "," ) + JString( buf );
	broadcast( 0 );
    break;
  case EXT_4:
    link.access(JIntegerData(ext_4));
	sprintf( buf, "%d", ext_4 );
	result = JString( viz_name ) + JString( "," ) + ext_4p + JString( "," ) + JString( buf );
	broadcast( 0 );
    break;
  case EXT_5:
    link.access(JIntegerData(ext_5));
	sprintf( buf, "%d", ext_5 );
	result = JString( viz_name ) + JString( "," ) + ext_5p + JString( "," ) + JString( buf );
	broadcast( 0 );
    break;
  default:
    break;
  }
}


JArray JVizObjectObj::getProperties() {
  JArray properties;
  properties.append(JStringProperty("viz_name", viz_name));
  properties.append(JStringProperty("ext_1p", ext_1p));
  properties.append(JStringProperty("ext_2p", ext_2p));
  properties.append(JStringProperty("ext_3p", ext_3p));
  properties.append(JStringProperty("ext_4p", ext_4p));
  properties.append(JStringProperty("ext_5p", ext_5p));
  return properties;
}


boolean JVizObjectObj::updateProperty(JProperty& prop) {
  if (prop.getName() == JString("viz_name")) {
    viz_name = ((JStringProperty*)&prop)->value;
    return true;
  } else if (prop.getName() == JString("ext_1p")) {
    ext_1p = ((JStringProperty*)&prop)->value;
    return true;
  } else if (prop.getName() == JString("ext_2p")) {
    ext_2p = ((JStringProperty*)&prop)->value;
    return true;
  } else if (prop.getName() == JString("ext_3p")) {
    ext_3p = ((JStringProperty*)&prop)->value;
    return true;
  } else if (prop.getName() == JString("ext_4p")) {
    ext_4p = ((JStringProperty*)&prop)->value;
    return true;
  } else if (prop.getName() == JString("ext_5p")) {
    ext_5p = ((JStringProperty*)&prop)->value;
    return true;
  }
  return false;
}


