#if !defined( _JRCSVFileReaderObj_h )
#define _JRCSVFileReaderObj_h
#include "JAddObj.h"
#include "JCriticalSection.h"
#include "JFile.h"
#include "JFileInputStream.h"

#include <stdio.h>
#define MAX_OUTPUTS 40

class 
#if defined(_EXTERNAL_DLL)
  DllExport
#else
  DllImport 
#endif
JRCSVFileReaderObj : public JAddObj {
  protected:
    virtual void writeContent(class JOutputStream& os);
    virtual void readContent(class JDictionary& dict);
  public:
    enum {
      ON,
      TICK,
	INFILE
	};

    virtual const char* className() const;
    virtual JObject* clone() const;
    JRCSVFileReaderObj();
    virtual void draw(JGraphics g, int x, int y, int w, int h);
    virtual boolean inputAllowed(int n);
    virtual JString inputTag(int n);
    virtual JString outputTag(int n);
    virtual JFRect inputArea(int n);
    virtual JFRect outputArea(int n);
    virtual int inputFace(int n);
    virtual int outputFace(int n);
    virtual JFPoint inputPoint(int n, JLinkObj& link);
    virtual JFPoint outputPoint(int n, JLinkObj& link);
    virtual void engine(int n, JLinkObj& link);
    virtual JArray getProperties();
    virtual boolean updateProperty(JProperty& prop);
    virtual void access(int n, JLinkObj& link, const JDataType& data);

	virtual int outputType( int n );
	virtual int inputType( int n );
  private:

    // controls
    int on;
    int tick;

    // properties
    JString file;

	JFile inFile;
	FILE* inputStream;
	int inStreamAvailable;

    // outputs
    int r0;
    double rout[MAX_OUTPUTS];
};


#endif
